;-------------------------------------------------------------------------------------
;PHYSICAL LAYER / serIFII
;-------------------------------------------------------------------------------------

;bitte beachten - interruptsteuerung nun integriert.
;...d.h. die jeweiligen flag's mssen durch die software (de-,)aktiviert
;werden!!!!

;KURZBESCHREIBUNG:
;routine wird einmal pro timeslot(55,5s) aufgerufen um folgende aktionen
;auszufhren:---> - serial bus scannen bis daten eintreffen oder sendeanforderung eingeht
;		  	 ---> - senden nur wenn ,silence on the bus' condition gegeben ist!!! 
;	      	      - gepufferte daten senden(max.framesize 255byte)
;	      	      - daten aus fifo asynchron empfangen und puffern (max.framesize 255byte)
;			 ---> - aktiver empfang wenn host-adressen identisch, sonst passiver empfang!
;			 ---> - nur fehlerfreie (dor0/fe0) empfangene bytes werden im buffer gesp.
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;->HARDWARE-REGISTER
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;ucsr0a <=> uart status register							
;********Flag's in ucsr0a:	udre0 <=> data register (udr0) empty
;							txc0  <=> tx transfer complete
;		    				rxc0  <=> rx receive complete
;          					dor0  <=> overrun
;							fe0   <=> framing error
;
;--------------------------------------------------------------------------------
;udr0 <=> uart daten register
;--------------------------------------------------------------------------------
;ucsr0b <=> uart control register
;********Flag's in ucsr0b:	txen0 <=> transmitter enabled
;	           				rxen0 <=> receiver enabled
;
;
;
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;->SOFTWARE-FLAG-VARIABLEN
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;SEflagA <=> serial data communication flag variable
;********Flag's in SEflagA: 
;.equ	SEbusy  	=	7	;<=> activ data communication
;.equ	SEpassiv	=	6	;<=> data communication passiv 
;.equ	SEsil   	=	5	;<=> silence on bus 
;				             	 SILwait =((10 * x)* CONbaud)* 55,3s<cycle_timeslot> 			   
;.equ	RXframe 	=	4	;<=> new received data frame in buffer
;.equ	TXframe 	=	3	;<=> new data frame to transmit
;.equ	SEdir   	=	2	;<=> rx/tx ?
;.equ	SEerror 	=	1	;<=> frame error
;.equ	SEenabled	=	0	;<=> serial IF (dis-)enabled


;SEflagB <=> serial data communication flag variable
;********Flag's in SEflagB: 
;.equ	SErepeat	=	7	;<=> repeatermode enabled
;.equ	TXack		=	6	;<=> sende acknowledge...	
;.equ	WTack		=	5	;<=> acknowledge von host erwartet...
;.equ	WTackPAS	=	4	;<=> acknowledge von passivem host erwartet...
;
;.equ	newTX		=	2	;<=> signaliere new-data-frame-TX 
;.equ	reqTX		=	1	;<=> "       "  request-data-tx
;.equ	BRcast	=	0		;<=> broadcast frame received

;SEflagC <=> serial data communication flag variable
;********Flag's in SEflagC:

;.equ	TXready		=	7	;<=> tx abgeschlossen (abhngig von txc0(ucsr0a)
;.equ	FRbuild		=	6	;<=> framebuilder modifiert gerade rxbuffer
;.equ	SERcomACT		=	5	;<=> allgemeine sercom aktivitt die den rxbuffer belegt...
;.equ	SERwireless		=	4	;<=> wire-,(less) auswahlflag
;.equ	STARTsequ		=	3	;<=> startsequenz
;.equ	PRAEok		=	2	;<=> prambel erkannt

;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;->TRANSFER-VARIABLEN (SRAM)
;----------------------------------------------------------------------------------
;----------------------------------------------------------------------------------
;
;RXbufferST <=> buffer start adress high 16-bit
;
;
;CNTbyte     <=> byte counter adress high 8-bit
;
;
;ADRhost     <=> host adress              8-bit
;
;
;WTsil	     <=> ,wait for silence on the bus' - counter
;
;-------------------------------------------------------------------------------------------
;->ENTRY
;-------------------------------------------------------------------------------------------

_uart_transfer_entry:
	lds	r18,ToutACK		;time out counter wert holen
	lds	r21,WTsil		;hole wait for silence... - counter
	lds	r20,CNTbyte
	lds	r19,SEflagVARa		;hole SEflag Variable A
	lds	r22,SEflagVARb		;"  " " " " " " "	  B
	lds	r17,SEflagVARc		;  "            "     C
	;	
	;
	;zuerst prfen ob serielle if enabled (...via program - mode )
	sbrs	r19,SEenabled
	rjmp		GO_HOMEx

	;TEST
	;prfe ob framebuilder gerade rxbuffer belegt !
;	sbrc	r17,FRbuild
;	rjmp		GO_HOMEx

	;prfe ob sercom gerade rxbuffer belegt !
	sbrc	r17,SERcomACT	
	rjmp		GO_HOMEx
	;
	;verarbeitung luft - also momentan taub !!!
	sbrc	r19,RXframe
	rjmp		GO_HOMEx
	
	;hier das tx-ready-flag checken (wird gesetzt wenn txc0 == 1)
	sbrs 	r17,TXready		;1==transmit ready ...
	rjmp		_serTXXXchk
	rjmp		_SERifbusyCK
		
;*******************************************************************************
	;tx noch nicht vollendet oder wireless wait????
_serTXXXchk:
	;nun bei wireless-mode verzgerung
	;wg. rx/tx umschaltung einfgen
	sbrs	r17,SERwireless
	rjmp	_serTXnoWLESS
	cpi		r18,wiWAIT		;wireless wait-start
	breq	_serTXwiWAIT	;loop startet...
;********************************************
	;loop ende?
	tst	r18	
	breq	_serTXnoWLESSb	;fertig...
	dec	r18
	rjmp	__SAVvarC

;********************************************
	;wait loop start
_serTXwiWAIT:
	sbis	ucsr0a,txc0
	rjmp		__SAVvarC
	sbi		ucsr0a,txc0		;lschen...
	;rx enabled wenn tx fertig	
	cbi		porte,pine2	
	dec		r18
	rjmp	__SAVvarC
;********************************************
	;wait end....
_serTXnoWLESSb:
	sbi 	ucsr0b,rxen0
	;rs485 tran
	sbr		r17,1<<TXready
	cbr		r19,1<<SEbusy
	;wait counter preset
	ldi		r18,wiWAIT		;wireless wait-start
	sts		SEflagVARc,r17
	rjmp		GO_HOME



;************kein wireless-mode**************
_serTXnoWLESS:
	sbis	ucsr0a,txc0
	rjmp		__SAVvarC
	sbi		ucsr0a,txc0		;lschen...
	cbi		porte,pine2	
	nop
	sbi 	ucsr0b,rxen0
	;rs485 tran
	sbr		r17,1<<TXready
	cbr		r19,1<<SEbusy
	;wait counter preset
	ldi		r18,wiWAIT		;wireless wait-start
__SAVvarC:
	sts		SEflagVARc,r17
	rjmp		GO_HOME







	;===============================================

_SERifbusyCK:
	;... ist das modul schon in aktion ???
	lds		r16,fifoVAR

	sbrc	r22,WTack	;warte noch auf acknowledge
	rjmp	_SERifbusyACKN

	sbrs	r19,SEbusy		;<1> datacommunication activ
	rjmp	_serNOTbsy		;..... no datacommunication !

	rjmp	_uart_direction_check

_SERifbusyACKN:
	sbrs	r16,fifoNEW
	rjmp	timOUTchk
	;daten eingetroffen == timeout sequenz resetten 
	sbr	r19,1<<SEbusy
	cbr	r19,1<<SEdir
	ldi	r21,SILwait
	ldi	r18,wiWAIT
	rjmp	_uart_direction_check


;-------------------------------------------------------------------------------------------
;->TIMEOUT... whrend auf Acknowledge gewartet wird...
;++++ NEU ++++
;25-03-06
;-> wartezeit auf acknowledge frame nun variabel <=> von der frame size abhngig !
;[WTackCTh|WTackCTh]
;
;WTackCTl
;-------------------------------------------------------------------------------------------
;noch kein byte im buffer == timeout sequenz weiterfhren!!

timOUTchk:
	clr	yh
	clr	yl
	lds	zl,WTackCTl
	lds	zh,WTackCTh
	cp	zl,yl
	cpc	zh,yh
	breq	timOUTchkD		;zeit ist abgelaufen == repeat oder?
	;counter -1
	clr	yh
	ldi	yl,1
	sub	zl,yl
	sbc	zh,yh
	sts	WTackCTl,zl
	sts	WTackCTh,zh
	jmp	GO_HOME			    ;zeit luft  === noch in der schleife !	


;-------------------------------------------------------------------------------------------
;->TX-REPEAT... nach timeout x-mal...
;-------------------------------------------------------------------------------------------
;
timOUTchkD:
	;oh... timeout
	;nun repeat-counter prfen
	;ggf.-1 oder wenn 0 beenden	
	lds	r16,repeatCNT		;repeat counter variable
	tst	r16			;repeat counter
	breq	_serIF_NACK_REP	
	dec	r16
	sts	repeatCNT,r16		;repeat counter variable
	;
	sbr	r19,1<<TXframe		;wiederhole tx-zyklus bis repeat counter=0
	cbr	r22,1<<WTack
	cbr	r19,1<<SEsil	;umschaltzeit rx/tx
	rjmp	_serTXchk	;gehe auf sendung
	;
_serIF_NACK_REP:
	;repeatCNT definieren
	lds	r20,remFLAG
	sbrs	r20,RTon
	rjmp	_serIF_NACK_REP_NOREM
	sbrc	r20,RTgroup
	rjmp	_serIF_NACK_REP_NOREM

	ldi	r20,REPTXdefREM	;0=default
	rjmp	_serIF_NACK_REP_GO
_serIF_NACK_REP_NOREM:	;-> TX wiederholungssequenz == 4
	ldi	r20,REPTXdef	;2=default
_serIF_NACK_REP_GO:
	sts	repeatCNT,r20
	cbr	r19,1<<SEbusy
	cbr	r22,1<<WTack	;die zeit ist um --- anscheinend hat der empfnger
	clr	r20
	rjmp	GO_HOME			;den frame nicht erhalten und sendet deswegen kein
						;acknowledge-frame !





;-------------------------------------------------------------------------------------------
;->KEIN AKTIVER DATENTRANSFER 
;-------------------------------------------------------------------------------------------
_serNOTbsy:
	;
	sbrc	r19,TXframe
	rjmp		_serTXchk
	sbrs	r16,fifoNEW		;neue daten im fifo-in
	rjmp		GO_HOMExx					
	cbr	r19,1<<SEpassiv
	sbr	r19,1<<SEbusy		;heit das soeben neuer datenframe
	cbr	r19,1<<SEdir		;empfangen wird und die flag's und
	clr	r20					;byte-counter dementsprechend prparieren
	rjmp	_uart_direction_check		;rx...
	;
	;  bis z. timeout

_serTXchk:
	;
	;hier nun die variable 
	;,silence on ...'ab-
	;checken

	sbrc	r22,TXack
	rjmp		_serTXchkGO
	sbrs	r19,SEsil		;<1>entspricht noch warten
	rjmp	_serTXchkGO		;<0>entspricht bus frei !
	dec	r21			;WTsil counter -1
	tst	r21			;...0 ?
	brne	GO_HOMExx			;noch >0 !
	;
_serTXchkGO:
	cbr	r19,1<<SEsil		;jetzt ist endgltig ruhe..
	sbr	r19,1<<SEbusy		;heit das ein neues frame gesendet
	sbr	r19,1<<SEdir		;werden soll und die flag's und byte
	clr	r20			;counter dementsprechend prpariert 
					;werden mssen
;aktiviere hier txen0....
;& deaktiviere rxen0 !!!
	cbi	ucsr0b,rxen0
	sbi	ucsr0b,txen0
	;
	sbi	porte,pine2			;rs485 transceiver tx
	;serCOM hat's entschieden
	;==tx
	;alles bisher empfangene 
	;lschen!
	sts	fifoIN,r20
	sts	fifoOUT,r20
	lds	r16,fifoVAR
	cbr	r16,1<<fifoERR
	cbr	r16,1<<fifoNEW
	sts	fifoVAR,r16
GO_HOMExx:
	rjmp	GO_HOME
	;
	;









;----------------------------------------------------------------------------------
;RX/TX
;----------------------------------------------------------------------------------
	;
	;
	;-> receive dor0 transmit
	;
_uart_direction_check:
	sbrc	r19,SEdir		;<1> data tx / <0> data rx		
	rjmp	_serACTIVtx		;..... transmit

	;
	;



;-------------------------------------------------------------------------------------------
;-> RECEIVING
;-------------------------------------------------------------------------------------------
	;-> check receive conditions
	;NEW VERSION !!!
	;interrupt based
	;a) check fifo state
	;b) clear fifoNEW flag !
	;
_STreceive:
	cbr	r16,1<<fifoNEW
	sts	fifoVAR,r16
	lds	zh,fifoIN		;fifo in counter
	lds	zl,fifoOUT		;fifo out counter
	mov	r17,zl
	cp	zh,zl
	breq	_serMISSINGrx	;same...countdown to timeout




;----------------------------------
;fifo-counter vor berlauf schtzen
;bereichsende erreicht dann wieder
;bei 0 beginnen...
;----------------------------------
	;fifo counters max.254
	cpi	zh,254	;fifoIN am limit
	brlo	_fifoRANGEok ;ne...
	tst	zl		;fifoOUT am unteren limit
	breq	_fifoRANGEok ; nix zu berechnen !
	mov	r10,zl	;fifoOUT(old)
	mov	r11,zh	;fifoIN(old)
	sub 	r11,r10	;fifoIN-fifoOUT = fifoDIFF	
	;nun fifoOUT auf 0
	clr	r10
	sts	fifoOUT,r10	;fifoOUT(new)=0
	;nun fifoIN == fifoDIFF
	sts	fifoIN,r11	;fifoIN(new)


	;fifoIN-daten kopieren
_fifoCOPY:
	ldi	zh,high(fifoSEG)
	ldi	zl,low(fifoSEG)
	mov	yl,r17;fifoOUT(old)
	clr	yh
	subi	yl,low(-fifoSEG)
	sbci	yh,high(-fifoSEG)
_fifoCOPYloop:
	ld	r16,y+	;daten aus alter fifoOUT-position holen
	st	z+,r16	;daten nach neuer position
	inc	r10		;fifoOUT(new)+1
	cp	r11,r10	;fifoIN(new) == fifoOUT(new)
	brne	_fifoCOPYloop

	rjmp	_STreceive

;-----------------------------
;-----------------------------


_fifoRANGEok:
	;take fifoOUT adress
	inc	r17
	sts	fifoOUT,r17		;store fifo out counter
	clr	zh
	subi	zl,low(-fifoSEG)
	sbci	zh,high(-fifoSEG)
	ld	r17,z			;stored data to r17
	rjmp	_uartRXpreCK

	;
	;---------------------------------------------------------
	;!!! --> hier timeout integrieren !!!
	;unvollstndiges frame (fehlende bytes) 
	;knnten alles blockieren !!!
	;a)timebase   = (1/baud)*9*2
	;b)routine reset !!!
	

_serMISSINGrx:	
	;
	lds	r16,WToutRX		;timeoutvariable holen
	tst	r16
	brne	_rxBYTEno
	;RX-ABBRUCH !!!
	ldi	r16,WToutVAR
	sts	WToutRX,r16		;timeout preset !!!
	;
	rjmp	_errRX_DATA		;timeout -> keine brauchbaren daten mehr zu erwarten - also break !
_rxBYTEno:
	dec	r16
	sts	WToutRX,r16	
	rjmp	GO_HOME			;....nein!

GO_HOMEx:
	rjmp	GO_HOME




;-------------------------------------------
	;-> wenn's flag gesetzt ist
	;   kann das byte aus dem
	;   udr0 abgeholt werden
	;   flag automatisch ge-
	;   lscht !	
	;hier:
	;bei aktivem wireless-mode
	;startbyte 0xffh abwarten...
	;->vor dem startbyte werden
	;  maximal 20 prebytes gesendet !
	
_uartRXpreCK:
	ldi	r16,WToutVAR
	sts	WToutRX,r16		;timeout preset !!!	
	;wireless?
	tst		r20			;prozesscounter
	brne	_uartRXpreCKa
	lds		r16,SEflagVARc
	sbrs	r16,SERwireless
	rjmp		_uartRXpreCKa	;wired rs485
	;wireless!
	sbrc	r16,STARTsequ
	rjmp		_uartRXpreCKa	;alles OK!
	;
	sbrc	r16,PRAEok
	rjmp		_uartRXpreCKc
	;voraussetzung: mind. 1byte der prambel 
	;				& anschl. startbyte erkannt !
	cpi		r17,0xaa	;prambel-byte...10101010
	brne	_uartRXpreCKb
	sbr		r16,1<<PRAEok
	sts		SEflagVARc,r16
	jmp		_uartRXpreCKb
	;startbyte ?
_uartRXpreCKc:
	cpi		r17,0xf0	;11110000	;startbyte
	brne	_uartRXpreCKd
	sbr		r16,1<<STARTsequ
	cbr		r16,1<<PRAEok	;kann gleich gelscht werden !
	sts		SEflagVARc,r16
	;fifo error bis hierher nicht relevant !
	lds	r16,fifoVAR
	cbr	r16,1<<fifoERR
	sts	fifoVAR,r16
	jmp		GO_HOME
	;
_uartRXpreCKd:
	;noch immer prambel-bytes ???
	cpi	r17,0xaa
	breq	_uartRXpreCKb
	;war was anderes -also bis zum timeout weiter prfen !!!
	cbr		r16,1<<PRAEok
	sts		SEflagVARc,r16
	;prebyte counter
_uartRXpreCKb:
	lds		r16,WIREset
	cpi		r16,praeFRAME+1		;+5		;
	brsh		_errRX_DATA		;... da wird irgendwas unbrauchbares empfangen....
	inc		r16
	sts		WIREset,r16
	jmp		GO_HOME
	;
	;
	;
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++



_uartRXpreCKa:
	lds		r16,fifoVAR
	sbrc		r16,fifoERR		;error...
	rjmp		_errRX_DATA		;da wird irgendwas unbrauchbares empfangen....
	sbrc	r19,SEpassiv		;
	rjmp	_serPASSIVrx		;passiv data receiving...
	rjmp	_serACTIVrx


;-------------------------------------------------------------------------------------------
;->TIMEOUT / ERROR  RECEIVING
;-------------------------------------------------------------------------------------------
_errRX_DATA:
	;empfang abgebrochen - keine daten mehr eingetroffen
	;also flags wieder lschen !
	lds		r16,SEflagVARc
	cbr		r16,1<<PRAEok
	sts		SEflagVARc,r16

	lds	r16,fifoVAR
	cbr	r16,1<<fifoERR
	sts	fifoVAR,r16
	rjmp	_RXerror		;frame nicht komplett oder fehlerhaft - also ,ERROR'

;-------------------------------------------------------------------------------------------
;->ACTIV RECEIVING
;-------------------------------------------------------------------------------------------
_serACTIVrx:

							;**************************************************************
							;MANCHESTER DECODER
							;=> noch festlegen ob nur bei aktivem remote aktiv ?!
							;**************************************************************
							lds	r16,SEflagVARc		
							;flag reg holen
							sbrc	r16,MANnibble	;0=erstes nibble
							rjmp	_serACTIVrx1man	;1=zweites nibble
							;then decode lower nibble
							mov	yl,r17
							call	_decodeMAN	;ergebnis (yl) decodieren
							swap	zl
							;ergebnis temporr speichern
							sts		RECBte,zl
							;flag f. zweites nibble setzen
							sbr		r16,1<<MANnibble
							sts		SEflagVARc,r16
							;...erstes nibble nicht in den buffer
							 jmp	GO_HOME

							;then decode higher nibble
							_serACTIVrx1man:
							mov		yl,r17			;higher nibble
							call	_decodeMAN	;ergebnis (yl) decodieren
							lds		r17,RECBte
							or		r17,zl
							;flag f. erstes  nibble setzen
							cbr		r16,1<<MANnibble
							sts		SEflagVARc,r16
						
							;*************************************************************
							cpi	r20,10
							brsh	_serACTIVrxSTANDARD	
							clr	zh
							mov	zl,r20
							;addiere startadresse buffer 
							subi	zl,low(-savAREArx)	;Add low byte ( x -(-y)) = x + y
							sbci	zh,high(-savAREArx)	;Add high byte with carry	
							st		z,r17
							;*************************************************************
				_serACTIVrxSTANDARD:
							;acknowledge?
							sbrc	r22,WTack	
							rjmp	_ACKframeCHK	;acknowledge erwartet
							;nun decodiertes byte in den buffer
							clr	zh
							mov	zl,r20
							;addiere startadresse buffer (bausteinabhngig)
							subi	zl,low(-RXbufferST)	;Add low byte ( x -(-y)) = x + y
							sbci	zh,high(-RXbufferST)	;Add high byte with carry
							st	z,r17			;empfangenes byte speichern
							;NEU++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
							;daten quersumme (f.ck-sum) erstellen
							lds	yl,CAcksumLdyn
							lds	yh,CAcksumHdyn
							clr	zh
							add	yl,r17
							adc	yh,zh
							sts	CAcksumLdyn,yl
							sts	CAcksumHdyn,yh
							;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
					_ACKframeCHK:
							;byte-cnt +1
							inc	r20
							rjmp	_CNTbyteCHK	
							



;-------------------------------------------------------------------------------------------
;->PASSIV RECEIVING
;-------------------------------------------------------------------------------------------
_serPASSIVrx:
	lds	r16,SEflagVARc		
	;flag reg holen
	sbrc	r16,MANnibble		;0=erstes nibble
	rjmp	_serPASSIVrx1man	;1=zweites nibble
	;flag f. erstes  nibble setzen
	sbr		r16,1<<MANnibble
	sts		SEflagVARc,r16
	jmp		GO_HOME
_serPASSIVrx1man:
	;flag f. erstes  nibble setzen
	cbr		r16,1<<MANnibble
	sts		SEflagVARc,r16
	inc	r20
	rjmp	_CNTbyteCHK





;-------------------------------------------------------------------------------------------
;->BYTE COUNTER PRFEN & PRE-SELECTION
;-------------------------------------------------------------------------------------------
;Logik:
;Aa)System als Repeater konfiguriert:
;		- Wenn MI6=1 dann aktiver Empfang da komplettes frame anschlieend gesendet wird
;		- Wenn MI6=0 dann normaler Betrieb (Broadcast/Zieladressierung) mglich
;Ab)System Direkt konfiguriert:
;		- Wenn MI6=1 dann passiver Empfang da komplettes Frame fr Repeater bestimmt!
;		- Wenn MI6=0 dann normaler Empfang (Broadcast/Zieladressierung) mglich
;Ba)Broadcast-Bit im Mode Identifier:
;		- Wenn MI7=1 dann erfolgt kein System-Adressvergleich - also generell aktiver Empfang
;		- Wenn MI7=0 dann Adressvergleich und nur bei bereinstimmung aktiver Empfang


_CNTbyteCHK:
	cpi	r20,10	;=10
	breq	TSTten
	cpi	r20,11
	brsh	testLIMIT
	rjmp	gogohome
	;<10 wird der noch nicht geprft
gogohome:
	rjmp	GO_HOME

TSTten:	
	;*
	;hier auf repeater,broadcast prfen
	;sowie empfangene host-adresse mit
	;gespeicherter system-host-adresse 
	;vergleichen
	;gleich   <=> aktiver  empfang
	;ungleich <=> passiver empfang	
	;*
	;
	;prfe ob repeatermode konfiguriert!
	sbrc	r22,SErepeat		;nur im repeater-mode kein 
					;berprfung der systemadresse
					;da daten auf jeden fall aktiv
					;gespeichert werden !!!
	rjmp	_SErepeater
	
	;system nicht als repeater konfiguriert... allerdings prfen
	;ob mode-identifier mi6(repeater) gesetzt ist. wrde hier
	;passiven rx bedeuten da ja nur der repeater aktiv empfangen
	;darf und das ganze frame mit gelschtem mi6 wieder aussenden
	;soll !!!!
	
	;empfangene mode identifier		
	ldi	zl,low(savAREArx)	;Add low byte ( x -(-y)) = x + y
	ldi	zh,high(savAREArx)	;Add high byte with carry
	ld	r17,z
	sbrs	r17,repeat
	rjmp	_SEbroadcast
	sbr	r19,1<<SEpassiv
	rjmp	GO_HOME			;bedeutet fr repeater bestimmt != passiver empfang

	
_SEbroadcast:	
	;prfe ob broadcast bit im mode identifier gesetzt?
	
	;empfangene mode identifier		
	ldi	zl,low(savAREArx)	;Add low byte ( x -(-y)) = x + y
	ldi	zh,high(savAREArx)	;Add high byte with carry
	ld	r17,z
	sbrc	r17,b_cast	;0=broad / 1=adress
	rjmp	_SEactivYK
	sbr	r22,1<<BRcast
	rjmp	_SEactiv
_SEactivYK:
	cbr	r22,1<<BRcast
	rjmp _SEcheckADR
	;
	;system als repeater konfiguriert... reagiert allerdings nur so wenn mode-identifier
	;bit6 gesetzt ist !
_SErepeater:
	
	;empfangene mode identifier		
	ldi	zl,low(savAREArx)	;Add low byte ( x -(-y)) = x + y
	ldi	zh,high(savAREArx)	;Add high byte with carry
	ld	r17,z
	sbrs	r17,repeat
	rjmp	_SEbroadcast		;bedeutet kein repeater-,aber vielleicht broadcast?
	cbr	r19,1<<SEpassiv
	rjmp	GO_HOME			;bedeutet repeaterbetrieb = aktiver empfang
	;
	;
	;kein repeater & kein broadcast... also adressen vergleichen !
_SEcheckADR:
	lds	r16,net_sou_adress
	;host-systemadresse
	clr	zh	
	ldi	zl,1			;empfangene host-adresse		
	subi	zl,low(-savAREArx)	;Add low byte ( x -(-y)) = x + y
	sbci	zh,high(-savAREArx)	;Add high byte with carry
	ld	r17,z
	cp	r17,r16
	brne	_ADRnotEQU
	;verzweige nach testLIMIT
	;19-12-03
_SEactiv:
	cbr	r19,1<<SEpassiv
	rjmp	testLIMIT
_ADRnotEQU:
	sbr	r19,1<<SEpassiv
	rjmp	testLIMIT
	;
	;------------------------------------------------------
	;aktiver empfang limit testen
testLIMIT:

	clr	zh			;hole den frame-size wert aus dem sram
	ldi	zl,5
	subi	zl,low(-savAREArx)	;Add low byte ( x -(-y)) = x + y
	sbci	zh,high(-savAREArx)	;Add high byte with carry
	ld	r16,z
	cp	r20,r16	

	;hier stndig aktuellen byte-counter
	;mit der empfangenen frame-size ver-
	;gleichen
	brsh	_READYtransfer	
	rjmp	GO_HOME	
	;
	;
	;
	;nun frame komplett bertragen
	;im anschluss flag's setzen..
	;INFO: HIER NUR DIE HARDWARESEITIGE BERPRFUNG
	;      WEITERE AKTIONEN (ACKNOWLEDGE...)WERDEN 
	;      LETZTENDLICH IN ABHNGIGKEIT DER FRAME-
	;      INHALTE DURCH DAS SERCOM-MODUL VERANLASST !
	;      D.H. NUR BEI RXFRAME=1 WIRD DAS SERCOM-MODUL
	;      AKTIV. EVTL. FEHLER ETC. WERDEN BAEACHTET !


_READYtransfer:	
	;frame size sichern wg.ck-summe
	sts	TEframeSIZ,r16
	;
	clr	r16
	sts		WIREset,r16
	lds		r16,SEflagVARc
	cbr		r16,1<<MANnibble
	sts		SEflagVARc,r16
	lds		r16,SEflagVARc
	cbr		r16,1<<STARTsequ
	sts		SEflagVARc,r16
	;
	sbrs	r22,WTack		;wurde ein normales frame empfangen 
	rjmp	_NOacknow
	;war ein acknowledge frame !
	;mu kein acknowledge gesendet werden
	sbrc	r19,SEpassiv
	rjmp	_RXerror		
	cbr	r22,1<<TXack		
	sbr	r19,1<<RXframe		;setzen da frameinhalt noch geprft werden soll
	cbr	r19,1<<SEerror		;egal ob hardware-error da frameinhalt ja noch 
					;geprft werden soll
	rjmp	_RXhome
	;
	;
_NOacknow:
	;ist kein acknowledge frame jetzt prfen ob aktiv/passiv
	sbrs	r19,SEpassiv
	rjmp	_RXnoerr
_RXerror:

	lds		r16,SEflagVARc
	cbr		r16,1<<STARTsequ
	sts		SEflagVARc,r16
	sbr	r19,1<<RXframe		;wird von sercom gelscht - keine weiterverarbeitung
	sbr	r19,1<<SEerror		;egal ob fehler da keine verarbeitung im sercom!
	rjmp	_RXhome
	;
	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;ist also ein perfektes daten-frame... vllig (hardware)-fehlerfrei
_RXnoerr:
	;a)frame size holen wg.ck-summe
	lds	yl,TEframeSIZ
	;b)lade kompltte quersumme 
	lds	zl,CAcksumLdyn
	lds	zh,CAcksumHdyn
	;c) CKtstSUM = Qsum[CAcksumHdyn|CAcksumLdyn] - CKsum[16bit] + (LABsou + FRsize)
	subi	yl,2	;adressiere MSB CKsum
	clr		yh		;hole den frame-size wert aus dem sram
	subi	yl,low(-RXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	yh,high(-RXbufferST)	;Add high byte with carry
	;empfangene checksumme MSB
	ld		r2,y+
	clr		r3
	;d) quersumme(gesamt) - quersumme cksum
	sub	zl,r2
	sbc	zh,r3
	;empfangene checksumme LSB
	ld		r2,y
	clr		r3
	;d) quersumme(gesamt) - quersumme cksum
	sub	zl,r2
	sbc	zh,r3
	;ergebnis:zl/zl == quersumme ohne cksum !
	;
	;e) lab source holen
	clr	yh	
	ldi	yl,3			;empfangenes LAB-Source-byte		
	subi	yl, low(-RXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	yh, high(-RXbufferST)	;Add high byte with carry
	ld	r2,y
	clr	r3
	;+quersumme
	add	zl,r2
	adc	zh,r3
	;f) framesize holen
	lds r2,TEframeSIZ
	clr	r3
	;+quersumme
	add	zl,r2
	adc	zh,r3


	;--------------------------------------------------
	;aus empfangenem frame berechnete ck-summe sichern
	;--------------------------------------------------
	sts	CAcksumLte,zl
	sts	CAcksumHte,zh
	;--------------------------------------------------
	sbr	r19,1<<RXframe	
	cbr	r22,1<<WTack
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;
	;
	;
_RXhome:
	;nun noch die ,wait for
	;silence...'- counter-var.
	;usw. definieren !
	clr	r16
	sts		WIREset,r16
	;
	;dyn. ck-quersummen lschen
	clr	yl
	sts	CAcksumLdyn,yl
	sts	CAcksumHdyn,yl

	;TEST
	;hier tx-repeat counter default setzen
	;=> nicht relevant bei broadcast
	;=> nicht relevant bei txack
	lds	r20,remFLAG
	sbrs	r20,RTon
	rjmp	_RXhome_NACK_REP_NOREM
	sbrc	r20,RTgroup
	rjmp	_RXhome_NACK_REP_NOREM
	ldi	r20,REPTXdefREM	;0=default
	rjmp	_RXhome_NACK_REP_GO
_RXhome_NACK_REP_NOREM:	;-> TX wiederholungssequenz 
	ldi	r20,REPTXdef	;2=default
_RXhome_NACK_REP_GO:
	sts	repeatCNT,r20
	;----------------------------
	clr	r20
	cbr	r19,1<<SEpassiv	
	cbr	r19,1<<SEbusy		;SEbbusy lschen da hardwareseitig komplett fertig
							;SERcom-Modul kann im anschluss die frameinhalte pr. 
	sbr	r19,1<<SEsil         ;nach setzen SEsil wird die
	;fifo clear
	clr		r17
	sts		fifoIN,r17
	sts		fifoOUT,r17
	;counter restaurieren
	ldi	r21,SILwait
	ldi	r18,wiWAIT

	rjmp	GO_HOME		














;-------------------------------------------------------------------------------------------
;->TRANSMITTING 
;-------------------------------------------------------------------------------------------
_serACTIVtx:
	sbis	ucsr0a,udre0		;check ob sender frei!
	rjmp	GO_HOME			;noch nicht frei = vielleicht
	;wired rs485 / wireless ???
	;
	tst	r20
	brne	_serACTIVtxGO
	lds		r16,SEflagVARc
	sbrs	r16,SERwireless
	rjmp		_serACTIVtxGO
	lds		r16,WIREset
	cpi		r16,praeFRAME	;15 (19,2kbps)
	brlo	_TXstabAFC
	breq	_TXstartFF
	jmp		_serACTIVtxGO
	;
_TXstabAFC:
	inc		r16
	sts		WIREset,r16
	ldi		r16,0xaa
	out		udr0,r16
	jmp		GO_HOME


_TXstartFF:
	;dyn. ck-quersummen lschen
	clr	yl
	sts	CAcksumLdyn,yl
	sts	CAcksumHdyn,yl
	;
	ldi		r16,0xf0	;11110000
	out		udr0,r16
	ldi		r16,praeFRAME+1
	sts		WIREset,r16
	jmp		GO_HOME

	;----------------------------------------------------------------
_serACTIVtxGO:
	clr		zh			;adressiere  sram
	mov		zl,r20			;addiere byte counter ....
	subi	zl,low(-TXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	zh,high(-TXbufferST)	;Add high byte with carry
	ld	r16,z			;hole tx-byte aus sram
	;fr ck-sum berechnun sichern
	mov	r10,r16
			
			
			
			
							;**************************************************************
							;MANCHESTER ENCODER
							;=> noch entscheiden ob nur bei remote access aktiv ?!
							;**************************************************************
							lds	r17,SEflagVARc		;flag reg holen
							sbrs	r17,MANnibble	;1=zweites nibble
							rjmp	_serACTIV1man	;0=erstes nibble
							;++ zweites nibble ++
							andi	r16,0b11110000	;nibbles freigeben
							mov		zl,r16
							call	_encodeMAN	;encoden ! (ergebnis yl)
							mov		r16,yl		;higher nibble
							;flag lschen
							cbr		r17,1<<MANnibble
							sts		SEflagVARc,r17
							;byte counter +1
							inc		r20			;byte-counter +1
							;backup byte in checksumme
							;add ck quersumme
							lds	yl,CAcksumLdyn
							lds	yh,CAcksumHdyn
							clr	zh
							add	yl,r10			;byte aus rx-buffer z. ck-sum
							adc	yh,zh
							sts	CAcksumLdyn,yl
							sts	CAcksumHdyn,yh
							rjmp	_serACTIVmanTX
							;**************************************************************
							;++erstes nibble++
							_serACTIV1man:
							swap	r16				;nibbles tauschen
							andi	r16,0b11110000	;getauschte nibbles freigeben
							mov		zl,r16
							call	_encodeMAN	;encoden ! (ergebnis yl)
							mov		r16,yl		;lower nibble
							;flag setzen
							sbr		r17,1<<MANnibble
							sts		SEflagVARc,r17
							;**************************************************************	
							;
							;
;****************************************
;encoded daten via usartX verschicken
;****************************************
_serACTIVmanTX:
	out	udr0,r16			
;****************************************
;CK-Sum erst berechnen wenn MANnibble=0
;****************************************
lds		r17,SEflagVARc
sbrc		r17,MANnibble
rjmp	GO_HOME
;****************************************		
clr	zh			;hole den frame-size wert aus dem sram
ldi	zl,5
subi	zl,low(-TXbufferST)	;Add low byte ( x -(-y)) = x + y
sbci	zh,high(-TXbufferST)	;Add high byte with carry
ld	r16,z
;framesize speichern
sts	TEframeSIZ,r16

									;hier stndig aktuellen byte-counter
									;mit der definierten frame-size ver-
									;gleichen
									cpi	   r20,0xff
									breq	_READYtx
									;r20=r16 == ready
									cp	r20,r16	
									brsh	_READYtx
									;letztes byte vor checksumme gesendet
									subi	r16,2
									cp	r20,r16	
									breq	_serACTIVtxCKsum	
									rjmp	GO_HOME	
	;
	;+++++++++++++++++++++++++++++++
	;CKSUM berechnen & in TXbuffer
	;+++++++++++++++++++++++++++++++
_serACTIVtxCKsum:
	;prfe ob's ein txack ist...
	sbrc	r22,TXack
	rjmp	_serACTIVtxCKsumNO
							
	;a)lade kompltte quersumme 
	lds	zl,CAcksumLdyn
	lds	zh,CAcksumHdyn
	;b) lab source holen
	clr	yh	
	ldi	yl,3			;empfangenes LAB-Source-byte		
	subi	yl, low(-TXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	yh, high(-TXbufferST)	;Add high byte with carry
	ld	r2,y
	clr	r3
	;+quersumme
	add	zl,r2
	adc	zh,r3
	;c) framesize holen
	lds r2,TEframeSIZ
	clr	r3
	;+quersumme
	add	zl,r2
	adc	zh,r3
	;d) CKtstSUM = Qsum[CAcksumHdyn|CAcksumLdyn]  + (LABsou + FRsize)
	;framesize holen
	lds 	yl,TEframeSIZ
	subi	yl,2	;adressiere MSB CKsum framesize -2
	clr		yh		;hole den frame-size wert aus dem sram
	subi	yl,low(-TXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	yh,high(-TXbufferST)	;Add high byte with carry
	;empfangene checksumme MSB
	st		y+,zh
	st		y,zl
_serACTIVtxCKsumNO:
	rjmp	GO_HOME	

	;----------------------------------


_READYtx:
	;NEU++++
	;zuerst framesize holen (wg. WTack !!!)
	lds yl,TEframeSIZ
	;prfe ob's ein broadcast frame ist !
	;und ob ein ack geschickt wird oder ob's eins war
	;
	ldi	zl,low(TXbufferST)	;Add low byte ( x -(-y)) = x + y
	ldi	zh,high(TXbufferST)	;Add high byte with carry
	ld	r16,z			;hole tx-byte aus sram
	sbrs	r16,b_cast
	rjmp	_READYtxNO		;1== adress / 0==broadcast
	;prfe ob's ein txack ist...
	sbrs	r22,TXack
	rjmp	_READYtxWTack
	;ist broadcast oder ein tx ack...
_READYtxNO:	
	cbr	r22,1<<WTack
	cbr	r22,1<<TXack
	rjmp	_READYtxGO
	;war' ein normales frame -- dann wtack
_READYtxWTack:
	cbr	r22,1<<TXack
	sbr	r22,1<<WTack
	;nun weiter...
_READYtxGO:
	;
	;NEU+++++++++++++++++++++++++++++++++++++
	;load counters mit konstante wg.wtack
	ldi	zl,low(TIrxBYTE)
	ldi	zh,high(TIrxBYTE)
	;konst(16bit) * framesize
	clr	yh
	mul	yl, zl	
	movw	r7:r6, r1:r0
	mul	yh, zl		
	add	r7, r0
	mul	zh, yl	
	add	r7, r0
	movw	zh:zl, r7:r6
	;..........................
	;NEW*** + net_sou_adress
	;minimiert kollisionen !
	clr	yh
	lds	yl,net_sou_adress
	add	zl,yl
	adc	zh,yh
	;..........................	
	sts	WTackCTl,zl
	sts	WTackCTh,zh
	;+++++++++++++++++++++++++++++++++++++++++

	;repeat tx-counter wg. group scanner sichern
	lds	r16,repeatCNT		;repeat counter variable
	sts	GhostQUAL,r16
	;
	;nun noch die ,wait for
	;silence...'- counter-var.
	;definieren !
	;
	ldi	r21,SILwait		;...
	ldi	r18,wiWAIT	;lade timeout-counter wg. acknowledge !	(100)
	clr	r16
	sts	WIREset,r16
	clr	r20
	;tx deaktivieren
	cbi	ucsr0b,txen0
	;standard defaults
	cbr	r19,1<<TXframe	
	sbr	r19,1<<SEsil            ;nach setzen SEsil wird die
	cbr	r19,1<<SEdir			;
	cbr	r22,1<<newTX
	;::::::::::::::
	;tx noch nicht abgeschlossen....
	lds	r17,SEflagVARc
	cbr		r17,1<<MANnibble
	cbr 	r17,1<<TXready	;1==transmit ready...
	sts	SEflagVARc,r17
	;
	rjmp	GO_HOME

;-------------------------------------------------------------------------------------------
;->GO_HOME
;-------------------------------------------------------------------------------------------
;
GO_HOME:
	sts	WTsil,r21		;noch speichern !
	sts	SEflagVARa,r19		;speichere SEflag Variable
	sts	SEFLAGVARb,r22		;  "      "      "
	sts	CNTbyte,r20		;speichere CNTbyte variable
	sts	ToutACK,r18		;noch speichern
	ret

.exit
